function [altitude,sigma,temp] = atmos
% tsl: temperature at sea level [K]
% asl: speed of sound at sea level [m/s]
% rhosl: density at sea level [kg/m^3]

tsl    = 288.15;
asl    = 340.29;
rhosl  = 1.225;
%**********************************************************************
%                  altitude [m]
%----------------------------------------------------------------------
      altitude = ...
        [-5.e03 ,    0.e03  ,    5.e03  ,   11.e03  ,   15.e03  , ...
         20.e03 ,   25.e03  ,   32.e03  ,   35.e03  ,   40.e03  , ...
         47.e03 ,   51.e03  ,   55.e03  ,   60.e03  ,   65e03   , ...
         71.e03 ,   75.e03  ,   80.e03,     84.85e03,  120e03];
%**********************************************************************
%                  sigma = ln[rho / rho_0] [-]
%----------------------------------------------------------------------
      sigma = ...
        [.45483,       0, -.49577, -1.2138, -1.8445, ...
        -2.6330, -3.4353, -4.5286, -5.0049, -5.7624, ...
        -6.7548, -7.2597, -7.7314, -8.3544, -9.0122, ...
        -9.8563, -10.467, -11.265, -12.018, -16.800];
%**********************************************************************
%                 air temperature  [K]
%----------------------------------------------------------------------
      temp = ...
        [320.65e0 ,  288.15e0 ,  223.15e0 ,  216.65e0 , 216.65e0 , ...
         216.65e0 ,  221.65e0 ,  228.65e0 ,  237.05e0 , 251.65e0 , ...
         270.65e0 ,  270.65e0 ,  259.45e0 ,  245.45e0 , 231.45e0 , ...
         214.65e0 ,  206.65e0 ,  196.65e0 ,  187.65e0 , 116.65e0];
